(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('prop-types'), require('styled-components')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'prop-types', 'styled-components'], factory) :
  (factory((global.reactGridFlexbox = {}),global.React,global.PropTypes,global.styled));
}(this, (function (exports,React,PropTypes,styled) { 'use strict';

  React = React && React.hasOwnProperty('default') ? React['default'] : React;
  PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
  styled = styled && styled.hasOwnProperty('default') ? styled['default'] : styled;

  var defaultBreakpoints = {
    tn: '0px', xs: '500px', sm: '768px', md: '992px',
    lg: '1200px', xl: '1440px', hg: '1920px'
  };

  var composeCSSMedia = function composeCSSMedia(cssProp, value, defaultValue) {
    var parseValue = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : function (_value) {
      return _value;
    };

    if (typeof value === 'string') {
      return cssProp + ': ' + parseValue(value) + ';';
    } else if (value === Object(value)) {
      return Object.keys(value).reduce(function (mediaString, key) {
        return '\n      ' + mediaString + '\n      @media (min-width: ' + (defaultBreakpoints[key] ? defaultBreakpoints[key] : key) + ') {\n        ' + cssProp + ': ' + parseValue(value[key]) + ';\n      }\n    ';
      }, '');
    }
    return defaultValue ? cssProp + ': ' + parseValue(defaultValue) + ';' : '';
  };

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var taggedTemplateLiteral = function (strings, raw) {
    return Object.freeze(Object.defineProperties(strings, {
      raw: {
        value: Object.freeze(raw)
      }
    }));
  };

  var _templateObject = taggedTemplateLiteral(['\n    ', '\n  '], ['\n    ', '\n  ']),
      _templateObject2 = taggedTemplateLiteral(['\n    display: grid;\n    ', '\n    ', '\n    ', '\n    ', '\n    ', '\n  '], ['\n    display: grid;\n    ', '\n    ', '\n    ', '\n    ', '\n    ', '\n  ']);

  var GridChild = function GridChild(_ref) {
    var children = _ref.children,
        _gridArea = _ref._gridArea;

    var StyledGridChild = styled.div(_templateObject, composeCSSMedia('grid-area', _gridArea, 'auto'));

    return React.createElement(
      StyledGridChild,
      null,
      children
    );
  };

  GridChild.propTypes = {
    children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
    _gridArea: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]).isRequired
  };

  var Grid = function Grid(_ref2) {
    var className = _ref2.className,
        children = _ref2.children,
        templateRows = _ref2.templateRows,
        templateColumns = _ref2.templateColumns,
        templateAreas = _ref2.templateAreas,
        gutter = _ref2.gutter,
        incGutterEdges = _ref2.incGutterEdges;

    var StyledGrid = styled.div(_templateObject2, composeCSSMedia('grid-template-columns', templateColumns, 'auto'), composeCSSMedia('grid-template-rows', templateRows, 'auto'), composeCSSMedia('grid-template-areas', templateAreas), composeCSSMedia('grid-gap', gutter), incGutterEdges ? composeCSSMedia('padding', gutter) : '');

    var gridChildren = React.Children.map(children, function (child) {
      if (child) {
        var gridChildProps = {
          '_gridArea': child.props._gridArea
        };

        var childPropsWithoutGridProps = Object.assign({}, child.props);

        Object.keys(gridChildProps).forEach(function (key) {
          delete childPropsWithoutGridProps[key];
        });

        var wrapped = React.createElement('div', gridChildProps, Object.assign({}, child, {
          props: childPropsWithoutGridProps
        }));

        return React.createElement(GridChild, wrapped.props);
      }
      return null;
    });
    return className ? React.createElement(
      'div',
      { className: className },
      React.createElement(
        StyledGrid,
        null,
        gridChildren
      )
    ) : React.createElement(
      StyledGrid,
      null,
      gridChildren
    );
  };

  Grid.propTypes = {
    children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
    className: PropTypes.string,
    templateColumns: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
    templateRows: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
    templateAreas: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]).isRequired,
    gutter: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
    incGutterEdges: PropTypes.bool
  };

  Grid.defaultProps = {
    className: null,
    templateColumns: 'auto',
    templateRows: 'auto',
    gutter: '0px',
    incGutterEdges: false
  };

  var _templateObject$1 = taggedTemplateLiteral(['\n    ', '\n    ', '\n    ', '\n    ', '\n    ', '\n  '], ['\n    ', '\n    ', '\n    ', '\n    ', '\n    ', '\n  ']),
      _templateObject2$1 = taggedTemplateLiteral(['\n    display: flex;\n    align-content: flex-start;\n    ', '\n    flex-wrap: ', ';\n    ', '\n    ', '\n    ', '\n\n    > * {\n      max-width: 100%;\n    }\n  '], ['\n    display: flex;\n    align-content: flex-start;\n    ', '\n    flex-wrap: ', ';\n    ', '\n    ', '\n    ', '\n\n    > * {\n      max-width: 100%;\n    }\n  ']);

  var FlexChild = function FlexChild(_ref) {
    var className = _ref.className,
        children = _ref.children,
        _flexBasis = _ref._flexBasis,
        _flexGrow = _ref._flexGrow,
        _flexReset = _ref._flexReset,
        _flexScroll = _ref._flexScroll,
        gutterSize = _ref.gutterSize;

    var StyledFlexChild = styled.div(_templateObject$1, composeCSSMedia('padding', gutterSize, null, function (value) {
      return 'calc(' + value + ' / 2)';
    }), _flexBasis ? '\n      ' + composeCSSMedia('flex-basis', _flexBasis, 'auto') + '\n    ' : '', _flexGrow ? '\n      flex-grow: 1;\n    ' : '', _flexScroll ? '\n      > * {\n        ' + composeCSSMedia('max-width', gutterSize, '0px', function (value) {
      return 'calc(100% - ' + value + ')';
    }) + '\n        ' + composeCSSMedia('max-heigth', gutterSize, '0px', function (value) {
      return 'calc(100% - ' + value + ')';
    }) + '\n        overflow: auto;\n      }\n    ' : '', _flexReset ? '\n      position: relative;\n      > * {\n        position: absolute;\n        ' + composeCSSMedia('min-width', gutterSize, '100%', function (value) {
      return 'calc(100% - ' + value + ')';
    }) + '\n        ' + composeCSSMedia('min-height', gutterSize, '100%', function (value) {
      return 'calc(100% - ' + value + ')';
    }) + '\n      }\n    ' : '');

    var renderChildWithClassName = function renderChildWithClassName() {
      return className ? React.createElement(
        'div',
        { className: className },
        children
      ) : children;
    };

    return _flexScroll || _flexReset ? React.createElement(
      StyledFlexChild,
      null,
      React.createElement(
        'div',
        null,
        renderChildWithClassName()
      )
    ) : React.createElement(
      StyledFlexChild,
      null,
      renderChildWithClassName()
    );
  };

  FlexChild.propTypes = {
    className: PropTypes.string,
    children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
    _flexBasis: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
    _flexGrow: PropTypes.bool,
    _flexScroll: PropTypes.bool,
    _flexReset: PropTypes.bool,
    gutterSize: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)])
  };

  FlexChild.defaultProps = {
    className: null,
    _flexBasis: null,
    _flexGrow: false,
    _flexScroll: false,
    _flexReset: false,
    gutterSize: '0px'
  };

  var Flex = function Flex(_ref2) {
    var className = _ref2.className,
        children = _ref2.children,
        direction = _ref2.direction,
        full = _ref2.full,
        wrap = _ref2.wrap,
        vAlign = _ref2.vAlign,
        hAlign = _ref2.hAlign,
        gutter = _ref2.gutter,
        incGutterEdges = _ref2.incGutterEdges;

    var isRow = direction === 'row' || direction === 'row-reverse';

    var composeAlignment = function composeAlignment() {
      var alignMap = {
        top: 'flex-start',
        bottom: 'flex-end',
        left: 'flex-start',
        right: 'flex-end',
        center: 'center',
        middle: 'center'
      };
      return '\n      ' + (vAlign ? (isRow ? 'align-items' : 'justify-content') + ': ' + alignMap(vAlign) + ';' : '') + '\n      ' + (hAlign ? (isRow ? 'justify-content' : 'align-items') + ': ' + alignMap(hAlign) + ';' : '') + '\n    ';
    };

    var StyledFlex = styled.div(_templateObject2$1, direction ? 'flex-direction: ' + direction + ';' : '', wrap && isRow ? 'wrap' : 'nowrap', composeAlignment(), incGutterEdges ? '\n      margin: 0;\n      ' + composeCSSMedia('padding', gutter, null, function (value) {
      return 'calc(' + value + ' / 2)';
    }) + '\n    ' : '\n      ' + composeCSSMedia('margin', gutter, null, function (value) {
      return 'calc(-' + value + ' / 2)';
    }) + '\n    ', full ? '\n      ' + composeCSSMedia('min-width', gutter, '0px', function (value) {
      return 'calc(100% + ' + value + ')';
    }) + '\n      ' + composeCSSMedia('min-height', gutter, '0px', function (value) {
      return 'calc(100% + ' + value + ')';
    }) + '\n    ' : '');

    var flexChildren = React.Children.map(children, function (child) {
      // Wrap any children in a div to prevent potential css flex layout overrides.
      if (child) {
        var flexChildProps = child.props ? Object.keys(FlexChild.defaultProps).reduce(function (props, key) {
          if (key !== 'className') {
            props[key] = child.props[key];
          }
          return props;
        }, {}) : {};

        var childPropsWithoutFlexProps = Object.assign({}, child.props);

        Object.keys(flexChildProps).forEach(function (key) {
          delete childPropsWithoutFlexProps[key];
        });

        var wrapped = React.createElement('div', flexChildProps, child.props ? Object.assign({}, child, {
          props: childPropsWithoutFlexProps
        }) : child);

        return React.createElement(FlexChild, _extends({}, wrapped.props, { gutterSize: gutter }));
      }
      return null;
    });

    return className ? React.createElement(
      'div',
      { className: className },
      React.createElement(
        StyledFlex,
        null,
        flexChildren
      )
    ) : React.createElement(
      StyledFlex,
      null,
      flexChildren
    );
  };

  Flex.propTypes = {
    children: PropTypes.oneOfType([PropTypes.node, PropTypes.arrayOf(PropTypes.node)]),
    className: PropTypes.string,
    direction: PropTypes.string,
    full: PropTypes.bool,
    wrap: PropTypes.bool,
    vAlign: PropTypes.string,
    hAlign: PropTypes.string,
    gutter: PropTypes.oneOfType([PropTypes.string, PropTypes.objectOf(PropTypes.string)]),
    incGutterEdges: PropTypes.bool
  };

  Flex.defaultProps = {
    className: null,
    direction: 'column',
    full: false,
    wrap: false,
    vAlign: null,
    hAlign: null,
    gutter: '0px',
    incGutterEdges: false
  };

  exports.Grid = Grid;
  exports.Flex = Flex;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
